#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Auswertung.ico
#AutoIt3Wrapper_Compression=3
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.6.1
	Author:         myName

	Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------
#include <allstyles.au3>
Dim $Path[2] = [@ScriptDir & "\Zeit.ini", @ScriptDir & "\Zeit2.ini"]
Dim $Graphic[11], $Label[11], $RGB[11]
Global $anzahl, $Max, $sortiert, $atm = 10
#Region ### START Koda GUI section ### Form=c:\users\fabian\desktop\zeit\form1.kxf
$Gui = GUICreate("Auswertung", 725, 610)
GUISetFont(12, 400, 0, "Arial")
$Grafik = GUICtrlCreateGraphic(16, 8, 369, 313)
$List1 = GUICtrlCreateList("", 5, 328, 76, 292, $WS_VSCROLL)
GUICtrlSetData(-1, "")
$List2 = GUICtrlCreateList("", 224, 328, 332, 292, $WS_VSCROLL)
$List3 = GUICtrlCreateList("", 83, 328, 139, 292, $WS_VSCROLL)
$ButtonZeit = GUICtrlCreateButton("Nach Zeit sortieren", 560, 328, 153, 41, 0)
$ButtonName = GUICtrlCreateButton("Nach Name sortieren", 560, 376, 153, 41, 0)
$Label1 = GUICtrlCreateLabel("Zeit kleiner", 560, 424, 80, 22)
$InputSek = GUICtrlCreateInput("Sek", 640, 424, 73, 26, BitOR($ES_AUTOHSCROLL, $ES_NUMBER))
$Label2 = GUICtrlCreateLabel("nicht bercksichtigen", 560, 456, 149, 22)
$Buttonberech = GUICtrlCreateButton("Neu berechnen", 560, 480, 153, 41, 0)
$Graphic[1] = GUICtrlCreateGraphic(400, 8, 17, 17)
$Graphic[2] = GUICtrlCreateGraphic(400, 40, 17, 17)
$Graphic[3] = GUICtrlCreateGraphic(400, 72, 17, 17)
$Graphic[4] = GUICtrlCreateGraphic(400, 104, 17, 17)
$Graphic[5] = GUICtrlCreateGraphic(400, 136, 17, 17)
$Graphic[6] = GUICtrlCreateGraphic(400, 168, 17, 17)
$Graphic[7] = GUICtrlCreateGraphic(400, 200, 17, 17)
$Graphic[8] = GUICtrlCreateGraphic(400, 232, 17, 17)
$Graphic[9] = GUICtrlCreateGraphic(400, 264, 17, 17)
$Graphic[10] = GUICtrlCreateGraphic(400, 296, 17, 17)
$Label[1] = GUICtrlCreateLabel("", 424, 8, 400, 22)
$Label[2] = GUICtrlCreateLabel("", 424, 40, 400, 22)
$Label[3] = GUICtrlCreateLabel("", 424, 72, 400, 22)
$Label[4] = GUICtrlCreateLabel("", 424, 104, 400, 22)
$Label[5] = GUICtrlCreateLabel("", 424, 136, 400, 22)
$Label[6] = GUICtrlCreateLabel("", 424, 168, 400, 22)
$Label[7] = GUICtrlCreateLabel("", 424, 200, 400, 22)
$Label[8] = GUICtrlCreateLabel("", 424, 232, 400, 22)
$Label[9] = GUICtrlCreateLabel("", 424, 264, 400, 22)
$Label[10] = GUICtrlCreateLabel("", 424, 296, 400, 22)
Global $RadioNuraktive = GUICtrlCreateRadio("Nur aktive Fenster", 568, 536, 153, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
Global $RadioAlleFenster = GUICtrlCreateRadio("Alle Fenster", 568, 560, 153, 17)
AdlibRegister("_Hotkeys", 500)
GUISetState(@SW_SHOW)
_addieren()
_zeichnen(0)
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			If FileExists(@TempDir & "\Auswertung.ini") <> 0 Then
				FileDelete(@TempDir & "\Auswertung.ini")
			EndIf
			Exit
		Case $Buttonberech
			_GUICtrlListBox_ResetContent($List1)
			_GUICtrlListBox_ResetContent($List2)
			_GUICtrlListBox_ResetContent($List3)
			GUICtrlDelete($Grafik)
			$Grafik = GUICtrlCreateGraphic(16, 8, 369, 313)
			_addieren()
			_zeichnen(0)
		Case $ButtonZeit
			_addieren()
			GUICtrlDelete($Grafik)
			$Grafik = GUICtrlCreateGraphic(16, 8, 369, 313)
			_GUICtrlListBox_ResetContent($List1)
			_GUICtrlListBox_ResetContent($List2)
			_GUICtrlListBox_ResetContent($List3)
			_zeichnen(1)
		Case $ButtonName
			_addieren()
			GUICtrlDelete($Grafik)
			$Grafik = GUICtrlCreateGraphic(16, 8, 369, 313)
			_GUICtrlListBox_ResetContent($List1)
			_GUICtrlListBox_ResetContent($List2)
			_GUICtrlListBox_ResetContent($List3)
			_zeichnen(2)
	EndSwitch
WEnd

Func _addieren()
	If FileExists(@ScriptDir & "\Zeit.ini") = 1 And FileExists(@ScriptDir & "\Zeit2.ini") = 1 Then
		If GUICtrlRead($RadioNuraktive) = $GUI_CHECKED Then
			$Sections = IniReadSectionNames(@ScriptDir & "\Zeit.ini")
			$2 = 0
		Else
			$Sections = IniReadSectionNames(@ScriptDir & "\Zeit2.ini")
			$2 = 1
		EndIf
		If FileExists(@TempDir & "\Auswertung.ini") = 1 Then
			FileDelete(@TempDir & "\Auswertung.ini")
		EndIf
		For $i = 1 To $Sections[0]
			$string = $Sections[$i]
			If $string <> "" And $string <> " " And $string <> "Program Manager" And $string <> "Start" Then ;
				$t = 0
				While 1
					If StringInStr($string, " - ") <> 0 Then
						$Position = StringInStr($string, " - ")
						$Position += 2
						$string = StringTrimLeft($string, $Position)
						$t = 1
					Else
						If $t = 1 Then
							$Zeit1 = IniRead(@TempDir & "\Auswertung.ini", $string, "Zeit", 0)
							$Zeit2 = IniRead($Path[$2], $Sections[$i], "Zeit", 0)
							$Zeit1 = Int($Zeit1)
							$Zeit2 = Int($Zeit2)
							$Zeit1 += $Zeit2
							IniWrite(@TempDir & "\Auswertung.ini", $string, "Zeit", $Zeit1)
						EndIf
						ExitLoop
					EndIf
				WEnd
				$string = $Sections[$i]
				$t = 0
				While 1
					If StringInStr($string, " * ") <> 0 Then
						$Position = StringInStr($string, " * ")
						$Position += 2
						$string = StringTrimLeft($string, $Position)
						$t = 1
					Else
						If $t = 1 Then
							$Zeit1 = IniRead(@TempDir & "\Auswertung.ini", $string, "Zeit", 0)
							$Zeit2 = IniRead($Path[$2], $Sections[$i], "Zeit", 0)
							$Zeit1 = Int($Zeit1)
							$Zeit2 = Int($Zeit2)
							$Zeit1 += $Zeit2
							IniWrite(@TempDir & "\Auswertung.ini", $string, "Zeit", $Zeit1)
						EndIf
						ExitLoop
					EndIf
				WEnd
				If StringInStr($Sections[$i], " * ") = 0 And StringInStr($Sections[$i], " - ") = 0 And $Sections[$i] <> "Desktop" Then
					$Zeit2 = IniRead($Path[$2], $Sections[$i], "Zeit", 0)
					If $Sections[$i] = "Program Manager" Then
						$string = "Desktop"
					Else
						$string = $Sections[$i]
					EndIf
					$Zeit2 = Int($Zeit2)
					IniWrite(@TempDir & "\Auswertung.ini", $string, "Zeit", $Zeit2)
				EndIf
			EndIf
		Next
	Else
		MsgBox(64, "", "Keine Zeitcounter Datei(en) gefunden :(")
		Exit
	EndIf
EndFunc   ;==>_addieren
Func _zeichnen($s)
	$Minimum = GUICtrlRead($InputSek)
	If $Minimum = "Sek" Or $Minimum = "" Then
		$Minimum = 500
	EndIf
	$Zeitpool = 0
	$Ab = 0
	$Sections = IniReadSectionNames(@TempDir & "\Auswertung.ini")
	For $i = 1 To $Sections[0]
		$Sections[$i] = StringReplace($Sections[$i], Chr(254), "[")
		$Sections[$i] = StringReplace($Sections[$i], Chr(255), "]")
		$Zeit = IniRead(@TempDir & "\Auswertung.ini", $Sections[$i], "Zeit", 0)
		$Zeit = Int($Zeit)
		If $Zeit >= $Minimum And $Sections[$i] <> "" And $Sections[$i] <> " " Then
			$Zeitpool += $Zeit
		Else
			$Sections[$i] = StringReplace($Sections[$i], "[", Chr(254))
			$Sections[$i] = StringReplace($Sections[$i], "]", Chr(255))
			IniDelete(@TempDir & "\Auswertung.ini", $Sections[$i])
		EndIf
	Next
	$Zeitpool = Int($Zeitpool)
	If $Zeitpool > 0 Then
		$Sections = IniReadSectionNames(@TempDir & "\Auswertung.ini")
		Dim $sortiert[$Sections[0]][3]
		For $i = 1 To $Sections[0]
			$Zeit = IniRead(@TempDir & "\Auswertung.ini", $Sections[$i], "Zeit", 0)
			$Zeit = Int($Zeit)
			$Value = $Zeit / $Zeitpool * 100
			$Value = Round($Value, 2)
			$sortiert[$i - 1][0] = $Value
			$sortiert[$i - 1][1] = $Zeit
			$sortiert[$i - 1][2] = $Sections[$i]
		Next
		For $i = 1 To $Sections[0]
			$wert = $sortiert[$i - 1][1]
			$d = 0
			$h = 0
			$m = 0
			$f = 0
			While ($wert / 86400) >= 1
				$d += 1
				$wert -= 86400
			WEnd
			While ($wert / 3600) >= 1
				$h += 1
				$wert -= 3600
			WEnd
			While ($wert / 60) >= 1
				$m += 1
				$wert -= 60
			WEnd
			$f = $wert
			$sortiert[$i - 1][1] = $d & "d " & $h & "h " & $m & "m " & $f & "s"
		Next
		If $s = 0 Then
			For $i = 1 To $Sections[0]
				$Sections[$i] = StringReplace($Sections[$i], Chr(254), "[")
				$Sections[$i] = StringReplace($Sections[$i], Chr(255), "]")
				$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(254), "[")
				$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(255), "]")
				$r = Random(0, 255)
				$g = Random(0, 255)
				$b = Random(0, 255)
				If $i > 10 Then
					ReDim $RGB[$i + 1]
				EndIf
				$RGB[$i] = "0x" & Hex($r, 2) & Hex($g, 2) & Hex($b, 2)
				GUICtrlSetGraphic($Grafik, $GUI_GR_COLOR, 0, "0x" & Hex($r, 2) & Hex($g, 2) & Hex($b, 2))
				GUICtrlSetGraphic($Grafik, $GUI_GR_PIE, 150, 155, 160, Round(3.6 * $Ab), Round(3.6 * $sortiert[$i - 1][0]))
				_GUICtrlListBox_AddString($List1, $sortiert[$i - 1][0] & "%")
				_GUICtrlListBox_AddString($List2, $sortiert[$i - 1][2])
				_GUICtrlListBox_AddString($List3, $sortiert[$i - 1][1])
				$Ab += Round($sortiert[$i - 1][0], 2)
			Next
		EndIf

		If $s = 1 Then
			$Ab = 0
			_ArraySort($sortiert)
			For $i = 1 To $Sections[0]
				$Sections[$i] = StringReplace($Sections[$i], Chr(254), "[")
				$Sections[$i] = StringReplace($Sections[$i], Chr(255), "]")
				$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(254), "[")
				$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(255), "]")
				$r = Random(0, 255)
				$g = Random(0, 255)
				$b = Random(0, 255)
				If $i > 10 Then
					ReDim $RGB[$i + 1]
				EndIf
				$RGB[$i] = "0x" & Hex($r, 2) & Hex($g, 2) & Hex($b, 2)
				GUICtrlSetGraphic($Grafik, $GUI_GR_COLOR, 0, "0x" & Hex($r, 2) & Hex($g, 2) & Hex($b, 2))
				GUICtrlSetGraphic($Grafik, $GUI_GR_PIE, 150, 155, 160, Round(3.6 * $Ab), Round(3.6 * $sortiert[$i - 1][0]))
				_GUICtrlListBox_AddString($List1, $sortiert[$i - 1][0] & "%")
				_GUICtrlListBox_AddString($List2, $sortiert[$i - 1][2])
				_GUICtrlListBox_AddString($List3, $sortiert[$i - 1][1])
				$Ab += Round($sortiert[$i - 1][0], 2)
			Next
		EndIf
		If $s = 2 Then
			$Ab = 0
			_ArraySort($sortiert, 0, 0, 0, 2)
			For $i = 1 To $Sections[0]
				$Sections[$i] = StringReplace($Sections[$i], Chr(254), "[")
				$Sections[$i] = StringReplace($Sections[$i], Chr(255), "]")
				$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(254), "[")
				$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(255), "]")
				$r = Random(0, 255)
				$g = Random(0, 255)
				$b = Random(0, 255)
				If $i > 10 Then
					ReDim $RGB[$i + 1]
				EndIf
				$RGB[$i] = "0x" & Hex($r, 2) & Hex($g, 2) & Hex($b, 2)
				GUICtrlSetGraphic($Grafik, $GUI_GR_COLOR, 0, "0x" & Hex($r, 2) & Hex($g, 2) & Hex($b, 2))
				GUICtrlSetGraphic($Grafik, $GUI_GR_PIE, 150, 155, 160, Round(3.6 * $Ab), Round(3.6 * $sortiert[$i - 1][0]))
				_GUICtrlListBox_AddString($List1, $sortiert[$i - 1][0] & "%")
				_GUICtrlListBox_AddString($List2, $sortiert[$i - 1][2])
				_GUICtrlListBox_AddString($List3, $sortiert[$i - 1][1])
				$Ab += Round($sortiert[$i - 1][0], 2)
			Next
		EndIf
		For $i = 1 To 10
			GUICtrlSetBkColor($Graphic[$i], 0xD4D0C8)
			GUICtrlSetData($Label[$i], "")
		Next
		$anzahl = UBound($sortiert)
		If $anzahl > 9 Then
			$anzahl = 10
			$Max = UBound($sortiert)
			$atm = 10
		Else
			$anzahl = UBound($sortiert)
			$Max = UBound($sortiert)
		EndIf
		For $i = 1 To $anzahl
			GUICtrlSetBkColor($Graphic[$i], $RGB[$i])
			$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(254), "[")
			$sortiert[$i - 1][2] = StringReplace($sortiert[$i - 1][2], Chr(255), "]")
			GUICtrlSetData($Label[$i], $sortiert[$i - 1][2])
		Next
		_WinAPI_RedrawWindow($Gui)
	Else
		MsgBox(64, "Achtung", "Keine Anwendung lief bereits lnger als " & $Minimum & " Sekunden. Bitte das Minimum verkleinern.")
	EndIf
EndFunc   ;==>_zeichnen

Func _up()
	If $Max > 10 And $atm < $Max Then
		If $atm + 10 > $Max Then
			$End = $Max
			For $i = 1 To 10
				GUICtrlSetBkColor($Graphic[$i], 0xD4D0C8)
				GUICtrlSetData($Label[$i], "")
			Next
		Else
			$End = $atm + 10
		EndIf
		$j = 0
		For $i = $atm + 1 To $End
			$j += 1
			GUICtrlSetBkColor($Graphic[$j], $RGB[$i])
			GUICtrlSetData($Label[$j], $sortiert[$i - 1][2])
		Next
		$atm += 10
	EndIf
EndFunc   ;==>_up
Func _down()
	$atm -= 20
	If $atm >= 0 Then
		If $atm + 10 > $Max Then
			$End = $Max
			For $i = 1 To 10
				GUICtrlSetBkColor($Graphic[$i], 0xD4D0C8)
				GUICtrlSetData($Label[$i], "")
			Next
		Else
			$End = $atm + 10
		EndIf
		$j = 0
		For $i = $atm + 1 To $End
			$j += 1
			GUICtrlSetBkColor($Graphic[$j], $RGB[$i])
			GUICtrlSetData($Label[$j], $sortiert[$i - 1][2])
		Next
		$atm += 10
	Else
		$atm += 20
	EndIf
EndFunc   ;==>_down

Func _Hotkeys()
	$wina = WinActive("Auswertung")
	If $wina <> 0 Then
		HotKeySet("!x", "_up")
		HotKeySet("!y", "_down")
		HotKeySet("{UP}", "_up")
		HotKeySet("{Down}", "_down")
		HotKeySet("{right}", "_up")
		HotKeySet("{left}", "_down")
		HotKeySet("{PGUP}", "_up")
		HotKeySet("{PGDN}", "_down")
	Else
		HotKeySet("!x")
		HotKeySet("!y")
		HotKeySet("{UP}")
		HotKeySet("{Down}")
		HotKeySet("{right}")
		HotKeySet("{left}")
		HotKeySet("{PGUP}")
		HotKeySet("{PGDN}")
	EndIf
EndFunc   ;==>_Hotkeys